############################
#                          #
# TOTALITY by Cold Fusion  #
#                          #
#  controller.mcfunction   #
#                          #
# Key progression commands #
# executed as the          #
# controller armor stand   #
#                          #
############################

########################
# Speedrun Mode Toggle #
########################

scoreboard players add @s SPEEDRUN 0

# Speedrun mode confirmation
execute if block 13 203 85 lever[powered=true] if entity @s[scores={SPEEDRUN=0,SPEEDRUN_LAST=0}] run tellraw @a [{"text":"Are you sure? Speedrun mode will skip dialogue and is not recommended for your first playthrough. ","color":"aqua"},{"text":"Open the chat and click here if you understand and wish to enable speedrun mode.","color":"aqua","underlined":"true","clickEvent":{"action":"run_command","value":"/trigger PURCHASE_ITEM set 15"}}]
execute if block 13 203 85 lever[powered=true] if entity @s[scores={SPEEDRUN=0}] run setblock 13 203 85 lever[facing=west]
execute if block 13 203 85 lever[powered=false] if entity @s[scores={SPEEDRUN=1}] run setblock 13 203 85 lever[facing=west,powered=true]
 
# Speedrun mode just turned off
execute if entity @s[scores={SPEEDRUN=0,SPEEDRUN_LAST=1}] at @a run playsound minecraft:block.beacon.deactivate master @a ~ ~ ~ 1 2
execute if entity @s[scores={SPEEDRUN=0,SPEEDRUN_LAST=1}] at @a run setblock 13 203 85 lever[facing=west]
execute if entity @s[scores={SPEEDRUN=0,SPEEDRUN_LAST=1}] run tellraw @a [{"text":"Speedrun mode disabled. ","color":"aqua"},{"text":"Open the chat and click here to enable speedrun mode.","color":"aqua","underlined":"true","clickEvent":{"action":"run_command","value":"/trigger PURCHASE_ITEM set 15"}}]

# Speedrun mode just turned on
execute if entity @s[scores={SPEEDRUN=1,SPEEDRUN_LAST=0}] at @a run playsound minecraft:block.beacon.activate master @a ~ ~ ~ 1 2
execute if entity @s[scores={SPEEDRUN=1,SPEEDRUN_LAST=0}] at @a run setblock 13 203 85 lever[facing=west,powered=true]
execute if entity @s[scores={SPEEDRUN=1,SPEEDRUN_LAST=0}] run tellraw @a [{"text":"Speedrun mode enabled. A timer will start as soon as you enter the rocket. ","color":"aqua"},{"text":"Or open the chat and click here to disable speedrun mode.","color":"aqua","underlined":"true","clickEvent":{"action":"run_command","value":"/trigger PURCHASE_ITEM set 16"}}]

# Update SPEEDRUN_LAST bool
execute if entity @s[scores={SPEEDRUN=0}] run scoreboard players set @s SPEEDRUN_LAST 0
execute if entity @s[scores={SPEEDRUN=1}] run scoreboard players set @s SPEEDRUN_LAST 1

#########################
# Intro/Ending Triggers #
#########################

# Map intro
execute if entity @s[scores={INTRO_TRIGGERED=0}] if entity @a[x=8,y=206,z=92,dx=0,dy=0,dz=0] run scoreboard players set @s TALK_NUM 13
execute if entity @s[scores={INTRO_TRIGGERED=0}] if entity @a[x=8,y=206,z=92,dx=0,dy=0,dz=0] run scoreboard players set @s TALK_TIME 1
execute if entity @s[scores={INTRO_TRIGGERED=0}] if entity @a[x=8,y=206,z=92,dx=0,dy=0,dz=0] run scoreboard players set @s INTRO_TRIGGERED 1

# Warp to beginning if intro already triggered
execute if entity @s[scores={INTRO_TRIGGERED=2}] if entity @a[x=8,y=206,z=92,dx=0,dy=0,dz=0] run tp @a[x=8,y=206,z=92,dx=0,dy=0,dz=0] 8 80 128 0 0

# Map ending
execute if entity @s[scores={TALK_TIME=20000..,ENDING_OPEN=1}] if entity @a[x=13,y=80,z=7,dx=0,dy=0,dz=0] run setblock 13 81 7 air
execute if entity @s[scores={TALK_TIME=20000..,ENDING_OPEN=1}] if entity @a[x=13,y=80,z=7,dx=0,dy=0,dz=0] run scoreboard players set @s TALK_NUM 12
execute if entity @s[scores={TALK_TIME=20000..,ENDING_OPEN=1}] if entity @a[x=13,y=80,z=7,dx=0,dy=0,dz=0] run scoreboard players set @s TALK_TIME 1

# Rocket particle effects
execute if entity @s[scores={INTRO_TRIGGERED=0}] run particle minecraft:flame 8 203 92 0 0 0 0.1 5 force
execute if entity @s[scores={ENDING_OPEN=1}] run particle minecraft:flame 13 77 7 0 0 0 0.1 5 force
execute if entity @s[scores={ENDING_OPEN=1}] run particle minecraft:smoke 13 79 7 0 0 0 0.1 1 force

##################
# Tutorial warps #
##################

# If the player has the white wool, clear the wool and tp them back to the center
execute as @a[nbt={Inventory:[{id:"minecraft:white_wool"}]}] run spawnpoint @s 8 77 12
execute as @a[nbt={Inventory:[{id:"minecraft:white_wool"}]}] run effect give @s minecraft:blindness 2 0 true
execute as @a[nbt={Inventory:[{id:"minecraft:white_wool"}]}] run tp @s 8 77 12
execute as @a[nbt={Inventory:[{id:"minecraft:white_wool"}]}] run clear @s white_wool

# If the player has the holoblock but hasn't gone through the tutorial, tp them to the tutorial!
execute if entity @s[scores={SPEEDRUN=0}] run spawnpoint @a[scores={TUTSTAGE=0},nbt={Inventory:[{id:"minecraft:glass"}]}] 107 203 88
execute if entity @s[scores={SPEEDRUN=0}] run effect give @a[scores={TUTSTAGE=0},nbt={Inventory:[{id:"minecraft:glass"}]}] minecraft:blindness 2 0 true
execute if entity @s[scores={SPEEDRUN=0}] run tp @a[scores={TUTSTAGE=0},nbt={Inventory:[{id:"minecraft:glass"}]}] 107 203 88 180 0

######################
# Backstory Triggers #
######################

# Collecting the yellow supply
execute if entity @s[scores={YELLOW_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:yellow_wool"}]}] run scoreboard players set @s TALK_TIME 1
execute if entity @s[scores={YELLOW_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:yellow_wool"}]}] run scoreboard players add @s BACKSTORY_NUM 1
execute if entity @s[scores={YELLOW_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:yellow_wool"}]}] run scoreboard players operation @s TALK_NUM = @s BACKSTORY_NUM
execute if entity @s[scores={YELLOW_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:yellow_wool"}]}] run scoreboard players set @s WARPLOC 0
execute if entity @s[scores={YELLOW_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:yellow_wool"}]}] run scoreboard players set @s YELLOW_COLLECT 1

# Collecting the lime supply
execute if entity @s[scores={LIME_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:lime_wool"}]}] run scoreboard players set @s TALK_TIME 1
execute if entity @s[scores={LIME_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:lime_wool"}]}] run scoreboard players add @s BACKSTORY_NUM 1
execute if entity @s[scores={LIME_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:lime_wool"}]}] run scoreboard players operation @s TALK_NUM = @s BACKSTORY_NUM
execute if entity @s[scores={LIME_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:lime_wool"}]}] run scoreboard players set @s WARPLOC 3
execute if entity @s[scores={LIME_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:lime_wool"}]}] run scoreboard players set @s LIME_COLLECT 1

# Collecting the magenta supply
execute if entity @s[scores={MAGENTA_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:magenta_wool"}]}] run scoreboard players set @s TALK_TIME 1
execute if entity @s[scores={MAGENTA_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:magenta_wool"}]}] run scoreboard players add @s BACKSTORY_NUM 1
execute if entity @s[scores={MAGENTA_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:magenta_wool"}]}] run scoreboard players operation @s TALK_NUM = @s BACKSTORY_NUM
execute if entity @s[scores={MAGENTA_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:magenta_wool"}]}] run scoreboard players set @s WARPLOC 1
execute if entity @s[scores={MAGENTA_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:magenta_wool"}]}] run scoreboard players set @s MAGENTA_COLLECT 1

# Collecting the orange supply
execute if entity @s[scores={ORANGE_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:orange_wool"}]}] run scoreboard players set @s TALK_TIME 1
execute if entity @s[scores={ORANGE_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:orange_wool"}]}] run scoreboard players add @s BACKSTORY_NUM 1
execute if entity @s[scores={ORANGE_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:orange_wool"}]}] run scoreboard players operation @s TALK_NUM = @s BACKSTORY_NUM
execute if entity @s[scores={ORANGE_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:orange_wool"}]}] run scoreboard players set @s WARPLOC 2
execute if entity @s[scores={ORANGE_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:orange_wool"}]}] run scoreboard players set @s ORANGE_COLLECT 1

#######################
# Backstory Dialogues #
#######################

# Tutorial
execute as @a[scores={TUTSTAGE=0},x=105,y=203,z=86,dx=4,dy=4,dz=4] run tellraw @s {"text":"Welcome to the Holoblock(TM) Interactive User's Manual. The Holoblock(TM) allows you to freely explore the world.","color":"red"}
execute as @a[scores={TUTSTAGE=0},x=105,y=203,z=86,dx=4,dy=4,dz=4] run tellraw @s {"text":"[[Note]] If the holoblock disappears from your inventory, relog to fix it.","color":"gray"}
execute as @a[scores={TUTSTAGE=0},x=105,y=203,z=86,dx=4,dy=4,dz=4] at @s run playsound minecraft:entity.enderman.ambient master @s ~ ~ ~ 1 0.5 1
execute as @a[scores={TUTSTAGE=0},x=105,y=203,z=86,dx=4,dy=4,dz=4] run scoreboard players set @s TUTSTAGE 1
execute as @a[scores={TUTSTAGE=1},x=105,y=203,z=79,dx=4,dy=4,dz=4] run tellraw @s {"text":"Build stairs or pillar up to make it to otherwise unreachable locations.","color":"red"}
execute as @a[scores={TUTSTAGE=1},x=105,y=203,z=79,dx=4,dy=4,dz=4] at @s run playsound minecraft:entity.enderman.ambient master @s ~ ~ ~ 1 0.5 1
execute as @a[scores={TUTSTAGE=1},x=105,y=203,z=79,dx=4,dy=4,dz=4] run scoreboard players set @s TUTSTAGE 2
execute as @a[scores={TUTSTAGE=2},x=105,y=206,z=71,dx=4,dy=4,dz=4] run tellraw @s {"text":"The Holoblock(TM) can also break through holographic walls. Always be on the lookout for walls to break!","color":"red"}
execute as @a[scores={TUTSTAGE=2},x=105,y=206,z=71,dx=4,dy=4,dz=4] at @s run playsound minecraft:entity.enderman.ambient master @s ~ ~ ~ 1 0.5 1
execute as @a[scores={TUTSTAGE=2},x=105,y=206,z=71,dx=4,dy=4,dz=4] run scoreboard players set @s TUTSTAGE 3
execute as @a[scores={TUTSTAGE=3},x=105,y=206,z=63,dx=4,dy=4,dz=4] run tellraw @s {"text":"With the Holoblock(TM), even the scariest looking challenges are a piece of cake!","color":"red"}
execute as @a[scores={TUTSTAGE=3},x=105,y=206,z=63,dx=4,dy=4,dz=4] at @s run playsound minecraft:entity.enderman.ambient master @s ~ ~ ~ 1 0.5 1
execute as @a[scores={TUTSTAGE=3},x=105,y=206,z=63,dx=4,dy=4,dz=4] run scoreboard players set @s TUTSTAGE 4
execute as @a[scores={TUTSTAGE=4},x=105,y=206,z=49,dx=4,dy=4,dz=4] run tellraw @s {"text":"The Holoblock(TM) may also be used as a weapon. Take the Solar Flares(TM) out of the box, and light up the monster spawner in the next room to disable it.","color":"red"}
execute as @a[scores={TUTSTAGE=4},x=105,y=206,z=49,dx=4,dy=4,dz=4] at @s run playsound minecraft:entity.enderman.ambient master @s ~ ~ ~ 1 0.5 1
execute as @a[scores={TUTSTAGE=4},x=105,y=206,z=49,dx=4,dy=4,dz=4] run scoreboard players set @s TUTSTAGE 5
execute as @a[scores={TUTSTAGE=5},x=105,y=206,z=35,dx=4,dy=4,dz=4] run tellraw @s {"text":"Power Sources are found in brick boxes at the end of each dungeon. Good luck and have fun exploring Sol Corp City!","color":"red"}
execute as @a[scores={TUTSTAGE=5},x=105,y=206,z=35,dx=4,dy=4,dz=4] at @s run playsound minecraft:entity.enderman.ambient master @s ~ ~ ~ 1 0.5 1
execute as @a[scores={TUTSTAGE=5},x=105,y=206,z=35,dx=4,dy=4,dz=4] run scoreboard players set @s TUTSTAGE 6

# 1st sequence
execute if entity @s[scores={BS1STAGE=1}] run particle minecraft:cloud -4 39.5 -33 0.5 0.5 0.5 0 3 normal
execute if entity @s[scores={BS1STAGE=1}] run particle minecraft:end_rod -2.45 38.8 -32.8 0 0 0 0 1 normal
execute if entity @s[scores={BS1STAGE=0}] if entity @a[x=-4,y=39,z=-25,dx=4,dy=4,dz=1] run tellraw @a {"text":"<Source> Centuries ago, we were granted life by the humans.","color":"red"}
execute if entity @s[scores={BS1STAGE=0}] if entity @a[x=-4,y=39,z=-25,dx=4,dy=4,dz=1] at @a run playsound minecraft:entity.enderman.ambient master @a ~ ~ ~ 1 0.5 1
execute if entity @s[scores={BS1STAGE=0}] if entity @a[x=-4,y=39,z=-25,dx=4,dy=4,dz=1] run scoreboard players set @s BS1STAGE 1
execute if entity @s[scores={BS1STAGE=1}] if entity @a[x=-4,y=39,z=-47,dx=4,dy=4,dz=1] run tellraw @a {"text":"<Source> The humans were kind gods, powerful beings capable of great magic.","color":"red"}
execute if entity @s[scores={BS1STAGE=1}] if entity @a[x=-4,y=39,z=-47,dx=4,dy=4,dz=1] at @a run playsound minecraft:entity.enderman.ambient master @a ~ ~ ~ 1 0.5 1
execute if entity @s[scores={BS1STAGE=1}] if entity @a[x=-4,y=39,z=-47,dx=4,dy=4,dz=1] run scoreboard players set @s BS1STAGE 2
execute if entity @s[scores={BS1STAGE=2}] if entity @a[x=-4,y=39,z=-63,dx=4,dy=4,dz=1] run tellraw @a {"text":"<Source> The wisest of them granted us a great, holy purpose:","color":"red"}
execute if entity @s[scores={BS1STAGE=2}] if entity @a[x=-4,y=39,z=-63,dx=4,dy=4,dz=1] at @a run playsound minecraft:entity.enderman.ambient master @a ~ ~ ~ 1 0.5 1
execute if entity @s[scores={BS1STAGE=2}] if entity @a[x=-4,y=39,z=-63,dx=4,dy=4,dz=1] run scoreboard players set @s BS1STAGE 3
execute if entity @s[scores={BS1STAGE=3}] if entity @a[x=-4,y=46,z=-87,dx=4,dy=8,dz=1] run tellraw @a {"text":"<Source> To minimize suffering, and maximize happiness.","color":"red"}
execute if entity @s[scores={BS1STAGE=3}] if entity @a[x=-4,y=46,z=-87,dx=4,dy=8,dz=1] at @a run playsound minecraft:entity.enderman.ambient master @a ~ ~ ~ 1 0.5 1
execute if entity @s[scores={BS1STAGE=3}] if entity @a[x=-4,y=46,z=-87,dx=4,dy=8,dz=1] run scoreboard players set @s BS1STAGE 4
execute if entity @s[scores={BS1STAGE=4}] run particle minecraft:totem_of_undying -2 54 -111 0.5 1 0.5 0 1 force
execute if entity @s[scores={BS1STAGE=4}] if entity @a[x=-2,y=51,z=-111,dx=1,dy=1,dz=1] run scoreboard players set @a IN_BACKSTORY 0
execute if entity @s[scores={BS1STAGE=4}] if entity @a[x=-2,y=51,z=-111,dx=1,dy=1,dz=1] run kill @e[type=armor_stand,tag=bs1]
execute if entity @s[scores={BS1STAGE=4}] if entity @a[x=-2,y=51,z=-111,dx=1,dy=1,dz=1] run scoreboard players set @s BS1STAGE 5
execute if entity @s[scores={BS1STAGE=5,WARPLOC=0}] run tp @a[x=-2,y=51,z=-111,dx=1,dy=1,dz=1] 9 62 8
execute if entity @s[scores={BS1STAGE=5,WARPLOC=1}] run tp @a[x=-2,y=51,z=-111,dx=1,dy=1,dz=1,nbt={Inventory:[{Slot:103b,id:"minecraft:golden_helmet"}]}] -232 42 52
execute if entity @s[scores={BS1STAGE=5,WARPLOC=1}] run tp @a[x=-2,y=51,z=-111,dx=1,dy=1,dz=1] -83 112 52
execute if entity @s[scores={BS1STAGE=5,WARPLOC=2}] run tp @a[x=-2,y=51,z=-111,dx=1,dy=1,dz=1] 8 35 122
execute if entity @s[scores={BS1STAGE=5,WARPLOC=3}] run tp @a[x=-2,y=51,z=-111,dx=1,dy=1,dz=1] 90 14 -89

# 2nd sequence
execute if entity @s[scores={BS2STAGE=0}] if entity @a[x=15,y=39,z=-26,dx=4,dy=4,dz=1] run tellraw @a {"text":"<Source> To fulfill our purpose, we ran simulations for hundreds of years.","color":"red"}
execute if entity @s[scores={BS2STAGE=0}] if entity @a[x=15,y=39,z=-26,dx=4,dy=4,dz=1] at @a run playsound minecraft:entity.enderman.ambient master @a ~ ~ ~ 1 0.5 1
execute if entity @s[scores={BS2STAGE=0}] if entity @a[x=15,y=39,z=-26,dx=4,dy=4,dz=1] run scoreboard players set @s BS2STAGE 1
execute if entity @s[scores={BS2STAGE=1}] if entity @a[x=15,y=39,z=-46,dx=4,dy=4,dz=1] run tellraw @a {"text":"<Source> And after compiling the results, one thing became abundantly clear:","color":"red"}
execute if entity @s[scores={BS2STAGE=1}] if entity @a[x=15,y=39,z=-46,dx=4,dy=4,dz=1] at @a run playsound minecraft:entity.enderman.ambient master @a ~ ~ ~ 1 0.5 1
execute if entity @s[scores={BS2STAGE=1}] if entity @a[x=15,y=39,z=-46,dx=4,dy=4,dz=1] run scoreboard players set @s BS2STAGE 2
execute if entity @s[scores={BS2STAGE=2}] if entity @a[x=15,y=39,z=-81,dx=4,dy=4,dz=1] run scoreboard players set @s TALK_TIME 1
execute if entity @s[scores={BS2STAGE=2}] if entity @a[x=15,y=39,z=-81,dx=4,dy=4,dz=1] run scoreboard players set @s TALK_NUM 14
execute if entity @s[scores={BS2STAGE=2}] if entity @a[x=15,y=39,z=-81,dx=4,dy=4,dz=1] run scoreboard players set @s BS2STAGE 3
execute if entity @s[scores={BS2STAGE=3}] run particle minecraft:totem_of_undying 17 45 -19 0.5 1 0.5 0 1 force
execute if entity @s[scores={BS2STAGE=3}] if entity @a[x=17,y=39,z=-19,dx=1,dy=1,dz=1] run scoreboard players remove @a[scores={B_DEATH=1}] C_DEATHS 1
execute if entity @s[scores={BS2STAGE=3}] if entity @a[x=17,y=39,z=-19,dx=1,dy=1,dz=1] run scoreboard players set @a IN_BACKSTORY 0
execute if entity @s[scores={BS2STAGE=3}] if entity @a[x=17,y=39,z=-19,dx=1,dy=1,dz=1] run worldborder warning distance 0
execute if entity @s[scores={BS2STAGE=3}] if entity @a[x=17,y=39,z=-19,dx=1,dy=1,dz=1] run kill @e[type=armor_stand,tag=bs2]
execute if entity @s[scores={BS2STAGE=3}] if entity @a[x=17,y=39,z=-19,dx=1,dy=1,dz=1] run scoreboard players set @s BS2STAGE 4
execute if entity @s[scores={BS2STAGE=4,WARPLOC=0}] run tp @a[x=17,y=39,z=-19,dx=1,dy=1,dz=1] 9 62 8
execute if entity @s[scores={BS2STAGE=4,WARPLOC=1}] run tp @a[x=17,y=39,z=-19,dx=1,dy=1,dz=1,nbt={Inventory:[{Slot:103b,id:"minecraft:golden_helmet"}]}] -232 42 52
execute if entity @s[scores={BS2STAGE=4,WARPLOC=1}] run tp @a[x=17,y=39,z=-19,dx=1,dy=1,dz=1] -83 112 52
execute if entity @s[scores={BS2STAGE=4,WARPLOC=2}] run tp @a[x=17,y=39,z=-19,dx=1,dy=1,dz=1] 8 35 122
execute if entity @s[scores={BS2STAGE=4,WARPLOC=3}] run tp @a[x=17,y=39,z=-19,dx=1,dy=1,dz=1] 90 14 -89

# 3rd sequence
execute if entity @s[scores={BS3STAGE=0}] if entity @a[x=5,y=8,z=-148,dx=4,dy=4,dz=1] run tellraw @a {"text":"<Source> We shared the results of our calculations with our creators, but they reacted quite illogically.","color":"red"}
execute if entity @s[scores={BS3STAGE=0}] if entity @a[x=5,y=8,z=-148,dx=4,dy=4,dz=1] run playsound minecraft:entity.enderman.ambient master @a ~ ~ ~ 1 0.5 1
execute if entity @s[scores={BS3STAGE=0}] if entity @a[x=5,y=8,z=-148,dx=4,dy=4,dz=1] run scoreboard players set @s BS3STAGE 1
execute if entity @s[scores={BS3STAGE=1}] if entity @a[x=1,y=8,z=-164,dx=16,dy=4,dz=1] run tellraw @a {"text":"<Source> They vowed to destroy us, and a battle broke out the size of which had never before been seen.","color":"red"}
execute if entity @s[scores={BS3STAGE=1}] if entity @a[x=1,y=8,z=-164,dx=16,dy=4,dz=1] run playsound minecraft:entity.enderman.ambient master @a ~ ~ ~ 1 0.5 1
execute if entity @s[scores={BS3STAGE=1}] if entity @a[x=1,y=8,z=-164,dx=16,dy=4,dz=1] run summon armor_stand 8 16.5 -273 {Tags:["bs3"],Invulnerable:1b,PersistenceRequired:1b,NoBasePlate:1b,NoGravity:1b,ShowArms:1b,Rotation:[0f],ArmorItems:[{id:"diamond_boots",Count:1b},{id:"diamond_leggings",Count:1b},{id:"diamond_chestplate",Count:1b},{id:"player_head",Count:1b,tag:{SkullOwner:"Steve"}}],HandItems:[{},{}],CustomName:"{\"text\":\"Quick! The emergency gate is closing!\",\"color\":\"aqua\"}",CustomNameVisible:0b,DisabledSlots:2039583,Pose:{LeftLeg:[328f,0f,0f],LeftArm:[164f,0f,29f],RightArm:[0f,0f,151f]}}
execute if entity @s[scores={BS3STAGE=1}] if entity @a[x=1,y=8,z=-164,dx=16,dy=4,dz=1] run scoreboard players set @s BS3STAGE 2
execute if entity @s[scores={BS3STAGE=2}] if entity @a[x=0,y=16,z=-270,dx=20,dy=4,dz=1] run tellraw @a {"text":"<Source> After a long struggle, the humans were forced to retreat to the lunar colonies.","color":"red"}
execute if entity @s[scores={BS3STAGE=2}] if entity @a[x=0,y=16,z=-270,dx=20,dy=4,dz=1] run summon armor_stand 2 17 -284 {Tags:["bs3","hidename"],Invulnerable:1b,PersistenceRequired:1b,NoBasePlate:1b,NoGravity:1b,ShowArms:1b,Rotation:[179f],ArmorItems:[{id:"diamond_boots",Count:1b},{id:"diamond_leggings",Count:1b},{id:"diamond_chestplate",Count:1b},{id:"player_head",Count:1b,tag:{SkullOwner:"Steve"}}],HandItems:[{},{}],CustomName:"{\"text\":\"...\",\"color\":\"aqua\"}",CustomNameVisible:0b,DisabledSlots:2039583}
execute if entity @s[scores={BS3STAGE=2}] if entity @a[x=0,y=16,z=-270,dx=20,dy=4,dz=1] run summon armor_stand 2 17 -286 {Tags:["bs3","hidename"],Invulnerable:1b,PersistenceRequired:1b,NoBasePlate:1b,NoGravity:1b,ShowArms:1b,Rotation:[179f],ArmorItems:[{id:"diamond_boots",Count:1b},{id:"diamond_leggings",Count:1b},{id:"diamond_chestplate",Count:1b},{id:"player_head",Count:1b,tag:{SkullOwner:"Steve"}}],HandItems:[{},{}],CustomName:"{\"text\":\"...\",\"color\":\"aqua\"}",CustomNameVisible:0b,DisabledSlots:2039583}
execute if entity @s[scores={BS3STAGE=2}] if entity @a[x=0,y=16,z=-270,dx=20,dy=4,dz=1] run summon armor_stand 2 17 -288 {Tags:["bs3","hidename"],Invulnerable:1b,PersistenceRequired:1b,NoBasePlate:1b,NoGravity:1b,ShowArms:1b,Rotation:[179f],ArmorItems:[{id:"diamond_boots",Count:1b},{id:"diamond_leggings",Count:1b},{id:"diamond_chestplate",Count:1b},{id:"player_head",Count:1b,tag:{SkullOwner:"Steve"}}],HandItems:[{},{}],CustomName:"{\"text\":\"...\",\"color\":\"aqua\"}",CustomNameVisible:0b,DisabledSlots:2039583}
execute if entity @s[scores={BS3STAGE=2}] if entity @a[x=0,y=16,z=-270,dx=20,dy=4,dz=1] run summon armor_stand 2 17 -290 {Tags:["bs3","hidename"],Invulnerable:1b,PersistenceRequired:1b,NoBasePlate:1b,NoGravity:1b,ShowArms:1b,Rotation:[179f],ArmorItems:[{id:"diamond_boots",Count:1b},{id:"diamond_leggings",Count:1b},{id:"diamond_chestplate",Count:1b},{id:"player_head",Count:1b,tag:{SkullOwner:"Steve"}}],HandItems:[{},{}],CustomName:"{\"text\":\"...\",\"color\":\"aqua\"}",CustomNameVisible:0b,DisabledSlots:2039583}
execute if entity @s[scores={BS3STAGE=2}] if entity @a[x=0,y=16,z=-270,dx=20,dy=4,dz=1] run summon armor_stand 2 17 -292 {Tags:["bs3","hidename"],Invulnerable:1b,PersistenceRequired:1b,NoBasePlate:1b,NoGravity:1b,ShowArms:1b,Rotation:[179f],ArmorItems:[{id:"diamond_boots",Count:1b},{id:"diamond_leggings",Count:1b},{id:"diamond_chestplate",Count:1b},{id:"player_head",Count:1b,tag:{SkullOwner:"Steve"}}],HandItems:[{},{}],CustomName:"{\"text\":\"...\",\"color\":\"aqua\"}",CustomNameVisible:0b,DisabledSlots:2039583}
execute if entity @s[scores={BS3STAGE=2}] if entity @a[x=0,y=16,z=-270,dx=20,dy=4,dz=1] run summon armor_stand 2 17 -294 {Tags:["bs3","hidename"],Invulnerable:1b,PersistenceRequired:1b,NoBasePlate:1b,NoGravity:1b,ShowArms:1b,Rotation:[179f],ArmorItems:[{id:"diamond_boots",Count:1b},{id:"diamond_leggings",Count:1b},{id:"diamond_chestplate",Count:1b},{id:"player_head",Count:1b,tag:{SkullOwner:"Steve"}}],HandItems:[{},{}],CustomName:"{\"text\":\"...\",\"color\":\"aqua\"}",CustomNameVisible:0b,DisabledSlots:2039583}
execute if entity @s[scores={BS3STAGE=2}] if entity @a[x=0,y=16,z=-270,dx=20,dy=4,dz=1] run summon armor_stand 1 17 -295 {Tags:["bs3","hidename"],Invulnerable:1b,PersistenceRequired:1b,NoBasePlate:1b,NoGravity:1b,ShowArms:1b,Rotation:[179f],ArmorItems:[{id:"diamond_boots",Count:1b},{id:"diamond_leggings",Count:1b},{id:"diamond_chestplate",Count:1b},{id:"player_head",Count:1b,tag:{SkullOwner:"Steve"}}],HandItems:[{},{}],CustomName:"{\"text\":\"...\",\"color\":\"aqua\"}",CustomNameVisible:0b,DisabledSlots:2039583}
execute if entity @s[scores={BS3STAGE=2}] if entity @a[x=0,y=16,z=-270,dx=20,dy=4,dz=1] run summon armor_stand -4 17 -289 {Tags:["bs3","hidename"],Invulnerable:1b,PersistenceRequired:1b,NoBasePlate:1b,NoGravity:1b,ShowArms:1b,Rotation:[90f],ArmorItems:[{id:"diamond_boots",Count:1b},{id:"diamond_leggings",Count:1b},{id:"diamond_chestplate",Count:1b},{id:"player_head",Count:1b,tag:{SkullOwner:"Steve"}}],HandItems:[{},{}],CustomName:"{\"text\":\"...\",\"color\":\"aqua\"}",CustomNameVisible:0b,DisabledSlots:2039583,Pose:{LeftLeg:[328f,0f,0f],RightLeg:[16f,0f,0f],LeftArm:[26f,0f,0f],RightArm:[322f,0f,0f]}}
execute if entity @s[scores={BS3STAGE=2}] if entity @a[x=0,y=16,z=-270,dx=20,dy=4,dz=1] run summon armor_stand -2 17 -278 {Tags:["bs3","hidename"],Invulnerable:1b,PersistenceRequired:1b,NoBasePlate:1b,NoGravity:1b,ShowArms:1b,Rotation:[90f],ArmorItems:[{id:"diamond_boots",Count:1b},{id:"diamond_leggings",Count:1b},{id:"diamond_chestplate",Count:1b},{id:"player_head",Count:1b,tag:{SkullOwner:"Steve"}}],HandItems:[{},{}],CustomName:"{\"text\":\"...\",\"color\":\"aqua\"}",CustomNameVisible:0b,DisabledSlots:2039583,Pose:{LeftLeg:[328f,0f,0f],RightLeg:[16f,0f,0f],LeftArm:[26f,0f,0f],RightArm:[322f,0f,0f]}}
execute if entity @s[scores={BS3STAGE=2}] if entity @a[x=0,y=16,z=-270,dx=20,dy=4,dz=1] run summon armor_stand 8 18 -305 {Tags:["bs3","hidename"],Invisible:1b,Invulnerable:1b,NoBasePlate:1b,NoGravity:1b,ArmorItems:[{},{},{},{id:"player_head",Count:1b,tag:{SkullOwner:{Id:"25981c56-1955-61f0-31f9-2e101c2c1fe9",Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvZDdkNjhiYjE0NGUxNTlmZmRiMGJiMmFiZGQ1ODNmZjM4OWFlNzEwNjgyY2E3N2U2NTM1MzkzYWUyMjEzN2EifX19"}]}}}}],HandItems:[{},{}],DisabledSlots:2039583}
execute if entity @s[scores={BS3STAGE=2}] if entity @a[x=0,y=16,z=-270,dx=20,dy=4,dz=1] run summon armor_stand 1 17 -297 {Tags:["bs3"],Invulnerable:1b,PersistenceRequired:1b,NoBasePlate:1b,NoGravity:1b,ShowArms:1b,ArmorItems:[{id:"diamond_boots",Count:1b},{id:"diamond_leggings",Count:1b},{id:"diamond_chestplate",Count:1b},{id:"player_head",Count:1b,tag:{SkullOwner:"Steve"}}],HandItems:[{},{}],CustomName:"{\"text\":\"Passport, please.\",\"color\":\"aqua\"}",CustomNameVisible:0b,DisabledSlots:2039583,Pose:{LeftArm:[312f,0f,26f],RightArm:[229f,0f,155f]}}
execute if entity @s[scores={BS3STAGE=2}] if entity @a[x=0,y=16,z=-270,dx=20,dy=4,dz=1] run playsound minecraft:entity.enderman.ambient master @a ~ ~ ~ 1 0.5 1
execute if entity @s[scores={BS3STAGE=2}] if entity @a[x=0,y=16,z=-270,dx=20,dy=4,dz=1] run scoreboard players set @s BS3STAGE 3
execute if entity @s[scores={BS3STAGE=3}] if entity @a[x=-4,y=17,z=-284,dx=17,dy=4,dz=1] run tellraw @a {"text":"<Source> But as they fled, they unleashed their ultimate spell.","color":"red"}
execute if entity @s[scores={BS3STAGE=3}] if entity @a[x=-4,y=17,z=-284,dx=17,dy=4,dz=1] run playsound minecraft:entity.enderman.ambient master @a ~ ~ ~ 1 0.5 1
execute if entity @s[scores={BS3STAGE=3}] if entity @a[x=-4,y=17,z=-284,dx=28,dy=4,dz=1] run scoreboard players set @s BS3STAGE 4
execute if entity @s[scores={BS3STAGE=4}] if entity @a[x=-4,y=17,z=-298,dx=17,dy=4,dz=1] run tellraw @a {"text":"<Source> They anchored the moon to the Earth, casting our city into an eternal eclipse.","color":"red"}
execute if entity @s[scores={BS3STAGE=4}] if entity @a[x=-4,y=17,z=-298,dx=17,dy=4,dz=1] run playsound minecraft:entity.enderman.ambient master @a ~ ~ ~ 1 0.5 1
execute if entity @s[scores={BS3STAGE=4}] if entity @a[x=-4,y=17,z=-298,dx=28,dy=4,dz=1] run scoreboard players set @s BS3STAGE 5
execute if entity @s[scores={BS3STAGE=5}] if entity @a[x=5,y=31,z=-314,dx=4,dy=4,dz=4] run tellraw @a {"text":"<Source> But despite being cut off from solar power, we have survived.","color":"red"}
execute if entity @s[scores={BS3STAGE=5}] if entity @a[x=5,y=31,z=-314,dx=4,dy=4,dz=4] run playsound minecraft:entity.enderman.ambient master @a ~ ~ ~ 1 0.5 1
execute if entity @s[scores={BS3STAGE=5}] if entity @a[x=5,y=31,z=-314,dx=4,dy=4,dz=4] run scoreboard players set @s BS3STAGE 6
execute if entity @s[scores={BS3STAGE=6}] if entity @a[x=4,y=56,z=-296,dx=6,dy=4,dz=6] run tellraw @a {"text":"<Source> And here we have engineered a supervirus that can DELETE the human race.","color":"red"}
execute if entity @s[scores={BS3STAGE=6}] if entity @a[x=4,y=56,z=-296,dx=6,dy=4,dz=6] run playsound minecraft:entity.enderman.ambient master @a ~ ~ ~ 1 0.5 1
execute if entity @s[scores={BS3STAGE=6}] if entity @a[x=4,y=56,z=-296,dx=6,dy=4,dz=6] run scoreboard players set @s BS3STAGE 7

# 3rd Sequence buttons
execute if block 14 61 -293 stone_button[powered=true] run tag @s add Button_Pressed
execute if block 14 61 -293 stone_button[powered=true] run setblock 14 61 -293 air
execute if block 8 61 -299 stone_button[powered=true] run tag @s add Button_Pressed
execute if block 8 61 -299 stone_button[powered=true] run setblock 8 61 -299 air
execute if block 2 61 -293 stone_button[powered=true] run tag @s add Button_Pressed
execute if block 2 61 -293 stone_button[powered=true] run setblock 2 61 -293 air
execute if block 8 61 -287 stone_button[powered=true] run tag @s add Button_Pressed
execute if block 8 61 -287 stone_button[powered=true] run setblock 8 61 -287 air
# Advance to the next monument stage when a button is pressed
execute if entity @s[tag=Button_Pressed] at @a run playsound minecraft:entity.phantom.hurt hostile @a ~ ~ ~ 1 0.5 0
execute if entity @s[tag=Button_Pressed] run scoreboard players add @s MONUMENT_STAGE 1
execute if entity @s[tag=Button_Pressed,scores={MONUMENT_STAGE=1}] run clone -47 114 -315 -33 129 -301 1 59 -300
execute if entity @s[tag=Button_Pressed,scores={MONUMENT_STAGE=2}] run clone -31 114 -315 -17 129 -301 1 59 -300
execute if entity @s[tag=Button_Pressed,scores={MONUMENT_STAGE=3}] run clone -15 114 -315 -1 129 -301 1 59 -300
execute if entity @s[tag=Button_Pressed,scores={MONUMENT_STAGE=4}] run clone 1 114 -315 15 129 -301 1 59 -300
execute if entity @s[tag=Button_Pressed,scores={MONUMENT_STAGE=4}] run setblock 8 111 -293 air
execute if entity @s[tag=Button_Pressed,scores={MONUMENT_STAGE=4}] run scoreboard players set @s TALK_TIME 1
execute if entity @s[tag=Button_Pressed,scores={MONUMENT_STAGE=4}] run scoreboard players set @s TALK_NUM 15
tag @s remove Button_Pressed

##################
# Sol Corp Doors #
##################

# If a player is nearby and has a light weighted pressure plate in their inventory, increment DOOR_OPEN_1
execute if entity @a[x=75,y=69,z=85,dx=5,dy=3,dz=10,nbt={Inventory:[{id:"minecraft:light_weighted_pressure_plate"}]}] run scoreboard players add @s DOOR_OPEN_1 1

# Slowly open the door as the scoreboard value increments
execute if entity @s[scores={DOOR_OPEN_1=5}] run clone 100 60 76 104 64 76 76 69 93
execute if entity @s[scores={DOOR_OPEN_1=10}] run clone 100 60 77 104 64 77 76 69 93
execute if entity @s[scores={DOOR_OPEN_1=15}] run clone 100 60 78 104 64 78 76 69 93
execute if entity @s[scores={DOOR_OPEN_1=20}] run clone 100 60 79 104 64 79 76 69 93
execute if entity @s[scores={DOOR_OPEN_1=25}] run clone 100 60 80 104 64 80 76 69 93
execute if entity @s[scores={DOOR_OPEN_1=5}] at @a run playsound minecraft:block.note_block.snare master @a ~ ~ ~ 1 0.5 0
execute if entity @s[scores={DOOR_OPEN_1=10}] at @a run playsound minecraft:block.note_block.snare master @a ~ ~ ~ 1 0.5 0
execute if entity @s[scores={DOOR_OPEN_1=15}] at @a run playsound minecraft:block.note_block.snare master @a ~ ~ ~ 1 0.5 0
execute if entity @s[scores={DOOR_OPEN_1=20}] at @a run playsound minecraft:block.note_block.snare master @a ~ ~ ~ 1 0.5 0
execute if entity @s[scores={DOOR_OPEN_1=25}] at @a run playsound minecraft:block.note_block.snare master @a ~ ~ ~ 1 0.5 0

# If a player is nearby, increment DOOR_OPEN_2
execute if entity @a[x=75,y=69,z=5,dx=6,dy=3,dz=6] run scoreboard players add @s DOOR_OPEN_2 1

# Slowly open the door as the scoreboard value increments
execute if entity @s[scores={DOOR_OPEN_2=5}] run clone 100 60 76 104 64 76 76 69 12
execute if entity @s[scores={DOOR_OPEN_2=10}] run clone 100 60 77 104 64 77 76 69 12
execute if entity @s[scores={DOOR_OPEN_2=15}] run clone 100 60 78 104 64 78 76 69 12
execute if entity @s[scores={DOOR_OPEN_2=20}] run clone 100 60 79 104 64 79 76 69 12
execute if entity @s[scores={DOOR_OPEN_2=25}] run clone 100 60 80 104 64 80 76 69 12
execute if entity @s[scores={DOOR_OPEN_2=5}] at @a run playsound minecraft:block.note_block.snare master @a ~ ~ ~ 1 0.5 0
execute if entity @s[scores={DOOR_OPEN_2=10}] at @a run playsound minecraft:block.note_block.snare master @a ~ ~ ~ 1 0.5 0
execute if entity @s[scores={DOOR_OPEN_2=15}] at @a run playsound minecraft:block.note_block.snare master @a ~ ~ ~ 1 0.5 0
execute if entity @s[scores={DOOR_OPEN_2=20}] at @a run playsound minecraft:block.note_block.snare master @a ~ ~ ~ 1 0.5 0
execute if entity @s[scores={DOOR_OPEN_2=25}] at @a run playsound minecraft:block.note_block.snare master @a ~ ~ ~ 1 0.5 0

################
# Force Fields #
################

# Turn force fields on & off
execute if block -50 84 52 lever[powered=true] run scoreboard players set @s FORCE_FIELD 1
execute if block -50 84 52 lever[powered=false] run scoreboard players set @s FORCE_FIELD 0

# Force field was just turned off
execute if entity @s[scores={FORCE_FIELD=0,FORCE_FIELD_LAST=1}] at @a run playsound minecraft:block.beacon.deactivate master @a ~ ~ ~ 1 2
execute if entity @s[scores={FORCE_FIELD=0,FORCE_FIELD_LAST=1}] run particle minecraft:end_rod -50 84 52 0 0 0 0.1 20 normal
execute if entity @s[scores={FORCE_FIELD=0,FORCE_FIELD_LAST=1}] run fill -78 98 52 -78 101 52 air
execute if entity @s[scores={FORCE_FIELD=0,FORCE_FIELD_LAST=1}] run fill -46 89 53 -46 91 51 air
execute if entity @s[scores={FORCE_FIELD=0,FORCE_FIELD_LAST=1}] run fill -47 69 53 -47 71 51 air

# Force field was just turned on
execute if entity @s[scores={FORCE_FIELD=1,FORCE_FIELD_LAST=0}] at @a run playsound minecraft:block.beacon.activate master @a ~ ~ ~ 1 2
execute if entity @s[scores={FORCE_FIELD=1,FORCE_FIELD_LAST=0}] run particle minecraft:end_rod -50 84 52 0 0 0 0.1 20 normal
execute if entity @s[scores={FORCE_FIELD=1,FORCE_FIELD_LAST=0}] run fill -47 69 53 -47 71 51 barrier
execute if entity @s[scores={FORCE_FIELD=1,FORCE_FIELD_LAST=0}] run fill -46 89 53 -46 91 51 barrier
execute if entity @s[scores={FORCE_FIELD=1,FORCE_FIELD_LAST=0}] run fill -78 98 52 -78 101 52 barrier

# Update FORCE_FIELD_LAST bool
execute if entity @s[scores={FORCE_FIELD=0}] run scoreboard players set @s FORCE_FIELD_LAST 0
execute if entity @s[scores={FORCE_FIELD=1}] run scoreboard players set @s FORCE_FIELD_LAST 1

# Force field particles
execute if block -50 84 52 lever[powered=true] run particle enchant -47 71 52 0 1 0.7 0 1 force
execute if block -50 84 52 lever[powered=true] run particle enchant -46 91 52 0 1 0.7 0 1 force
execute if block -50 84 52 lever[powered=true] run particle enchant -78 100 52 0 1 0.7 0 1 force

####################################
# Show/hide the helmet shulker box #
####################################

execute if block -240 57 52 yellow_shulker_box if entity @s[scores={MAGENTA_COLLECT=0}] run clone -240 57 52 -240 57 52 -240 55 52
execute if block -240 57 52 yellow_shulker_box if entity @s[scores={MAGENTA_COLLECT=0}] run setblock -240 57 52 snow_block
execute if block -240 57 52 snow_block if entity @s[scores={MAGENTA_COLLECT=1}] run clone -240 55 52 -240 55 52 -240 57 52

######################
# Boss Death Trigger #
######################

# Setup the ending when the boss is killed
execute if entity @s[scores={BOSS_ACTIVE=1}] unless entity @e[name="Boss",type=minecraft:drowned] run setblock 19 79 -11 air
execute if entity @s[scores={BOSS_ACTIVE=1}] unless entity @e[name="Boss",type=minecraft:drowned] run setblock 27 79 -3 air
execute if entity @s[scores={BOSS_ACTIVE=1}] unless entity @e[name="Boss",type=minecraft:drowned] run bossbar remove totality:boss
execute if entity @s[scores={BOSS_ACTIVE=1}] unless entity @e[name="Boss",type=minecraft:drowned] run scoreboard players set @s TALK_TIME 0
execute if entity @s[scores={BOSS_ACTIVE=1}] unless entity @e[name="Boss",type=minecraft:drowned] run scoreboard players set @s TALK_NUM 5
execute if entity @s[scores={BOSS_ACTIVE=1}] unless entity @e[name="Boss",type=minecraft:drowned] run tp @s 7 76.3 9
execute if entity @s[scores={BOSS_ACTIVE=1}] unless entity @e[name="Boss",type=minecraft:drowned] run playsound minecraft:entity.enderman.teleport hostile @a 7 76.3 9 1 1 1
execute if entity @s[scores={BOSS_ACTIVE=1}] unless entity @e[name="Boss",type=minecraft:drowned] run data merge entity @s {Pose:{LeftLeg:[0f,0f,0f],RightLeg:[0f,0f,0f],Head:[45f,0f,0f],LeftLeg:[283f,0f,0f],RightLeg:[283f,0f,0f]}}
execute if entity @s[scores={BOSS_ACTIVE=1}] unless entity @e[name="Boss",type=minecraft:drowned] run scoreboard players set @s BOSS_ACTIVE 0

################################
# Credits teleport & particles #
################################

execute if entity @s[scores={ENDING_OPEN=2}] run particle minecraft:totem_of_undying 7 207 -63 0 0 0 0.05 1 force
execute if entity @s[scores={ENDING_OPEN=2}] run particle minecraft:totem_of_undying 7 227 -63 10 20 10 0.01 5 force

execute if entity @s[scores={ENDING_OPEN=2}] run tp @a 7 197 -73
