###########################
#                         #
# TOTALITY by Cold Fusion #
#                         #
#   players.mcfunction    #
#                         #
#  Player-specific        #
#  commands               #
#                         #
###########################

####################################################
# Run the player-setup function on any new players #
####################################################

scoreboard players add @a PLAYER_SPAWNED 0
execute as @a[scores={PLAYER_SPAWNED=0}] run function t:player-setup

##############
# Saturation #
##############

# Give player saturation when their food bar goes down
effect give @a[scores={FOOD=..19}] saturation 1 0 true

################
# Advancements #
################

# Grant root advancements upon crash landing
advancement grant @a[x=8,y=80,z=128,dx=0,dy=0,dz=0] only t:announce/root
advancement grant @a[x=8,y=80,z=128,dx=0,dy=0,dz=0] only t:announce/announce
advancement grant @a[x=8,y=80,z=128,dx=0,dy=0,dz=0] only t:completion/root
advancement grant @a[x=8,y=80,z=128,dx=0,dy=0,dz=0] only t:challenges/root

# Grant completion advancements as the player explores the map
advancement grant @a[x=67,y=69,z=48,dx=4,dy=4,dz=8] only t:completion/d1_0
execute if entity @a[nbt={Inventory:[{id:"minecraft:light_weighted_pressure_plate"}]}] run advancement grant @a only t:completion/d1_1
advancement grant @a[x=78,y=48,z=96,dx=4,dy=4,dz=1] only t:completion/d1_2
advancement grant @a[x=6,y=51,z=27,dx=4,dy=4,dz=1] only t:completion/d1_3
execute if entity @a[nbt={Inventory:[{id:"minecraft:yellow_wool"}]}] run advancement grant @a only t:completion/yellow

advancement grant @a[x=-46,y=69,z=50,dx=8,dy=4,dz=4] only t:completion/d2_0
advancement grant @a[x=-67,y=59,z=78,dx=8,dy=4,dz=2] only t:completion/d2_1
advancement grant @a[x=-89,y=71,z=27,dx=8,dy=4,dz=50] only t:completion/d2_2
advancement grant @a[nbt={Inventory:[{Slot:103b,id:"minecraft:golden_helmet"}]}] only t:completion/d2_3
execute if entity @a[nbt={Inventory:[{id:"minecraft:magenta_wool"}]}] run advancement grant @a only t:completion/magenta

advancement grant @a[x=-75,y=63,z=-59,dx=49,dy=13,dz=61] only t:completion/d3_0
advancement grant @a[x=-63,y=39,z=-10,dx=4,dy=4,dz=1] only t:completion/d3_1
advancement grant @a[x=-30,y=39,z=-5,dx=4,dy=4,dz=1] only t:completion/d3_2
advancement grant @a[x=0,y=15,z=94,dx=16,dy=4,dz=20] only t:completion/d3_3
execute if entity @a[nbt={Inventory:[{id:"minecraft:orange_wool"}]}] run advancement grant @a only t:completion/orange

advancement grant @a[x=99,y=81,z=-41,dx=1,dy=4,dz=4] only t:completion/d4_0
advancement grant @a[x=61,y=62,z=-70,dx=40,dy=2,dz=55] only t:completion/d4_1
advancement grant @a[x=106,y=15,z=-57,dx=12,dy=20,dz=32] only t:completion/d4_2
advancement grant @a[x=6,y=24,z=-54,dx=4,dy=4,dz=4] only t:completion/d4_3
execute if entity @a[nbt={Inventory:[{id:"minecraft:lime_wool"}]}] run advancement grant @a only t:completion/lime

# For the holoblock ninja advancement, mark an armor piece as 'used' if it's been equipped
execute as @a[scores={C_HELMET_USED=0}] if entity @s[nbt={Inventory:[{Slot:103b,id:"minecraft:leather_helmet"}]}] run scoreboard players set @s C_HELMET_USED 1
execute as @a[scores={C_CHEST_USED=0}] if entity @s[nbt={Inventory:[{Slot:102b,id:"minecraft:leather_chestplate"}]}] run scoreboard players set @s C_CHEST_USED 1
execute as @a[scores={C_LEGGINGS_USED=0}] if entity @s[nbt={Inventory:[{Slot:101b,id:"minecraft:leather_leggings"}]}] run scoreboard players set @s C_LEGGINGS_USED 1
execute as @a[scores={C_BOOTS_USED=0}] if entity @s[nbt={Inventory:[{Slot:100b,id:"minecraft:leather_boots"}]}] run scoreboard players set @s C_BOOTS_USED 1

# Mark an item as collected if it is found in a player's inventory
execute as @a[scores={C_HELMET_GET=0}] if entity @a[nbt={Inventory:[{id:"minecraft:leather_helmet"}]}] run scoreboard players set @a C_HELMET_GET 1
execute as @a[scores={C_CHEST_GET=0}] if entity @a[nbt={Inventory:[{id:"minecraft:leather_chestplate"}]}] run scoreboard players set @a C_CHEST_GET 1
execute as @a[scores={C_LEGGINGS_GET=0}] if entity @a[nbt={Inventory:[{id:"minecraft:leather_leggings"}]}] run scoreboard players set @a C_LEGGINGS_GET 1
execute as @a[scores={C_BOOTS_GET=0}] if entity @a[nbt={Inventory:[{id:"minecraft:leather_boots"}]}] run scoreboard players set @a C_BOOTS_GET 1
execute as @a[scores={C_DOG_GET=0}] if entity @a[nbt={Inventory:[{id:"minecraft:wolf_spawn_egg"}]}] run scoreboard players set @a C_DOG_GET 1
execute as @a[scores={C_PICK_GET=0}] if entity @a[nbt={Inventory:[{id:"minecraft:iron_pickaxe"}]}] run scoreboard players set @a C_PICK_GET 1
execute as @a[scores={C_SWORD_GET=0}] if entity @a[nbt={Inventory:[{id:"minecraft:iron_sword"}]}] run scoreboard players set @a C_SWORD_GET 1
execute as @a[scores={C_SHIELD_GET=0}] if entity @a[nbt={Inventory:[{id:"minecraft:shield",tag:{Unbreakable:1}}]}] run scoreboard players set @a C_SHIELD_GET 1
execute as @a[scores={C_AXE_GET=0}] if entity @a[nbt={Inventory:[{id:"minecraft:iron_axe"}]}] run scoreboard players set @a C_AXE_GET 1
execute as @a[scores={C_WATER_GET=0}] if entity @a[nbt={Inventory:[{id:"minecraft:water_bucket"}]}] run scoreboard players set @a C_WATER_GET 1
execute as @a[scores={C_TRIDENT_GET=0}] if entity @a[nbt={Inventory:[{id:"minecraft:trident"}]}] run scoreboard players set @a C_TRIDENT_GET 1
execute as @a[scores={C_BOW_GET=0}] if entity @a[nbt={Inventory:[{id:"minecraft:bow"}]}] run scoreboard players set @a C_BOW_GET 1
execute as @a[scores={C_SHOVEL_GET=0}] if entity @a[nbt={Inventory:[{id:"minecraft:iron_shovel"}]}] run scoreboard players set @a C_SHOVEL_GET 1
execute as @a[scores={C_SHEARS_GET=0}] if entity @a[nbt={Inventory:[{id:"minecraft:shears"}]}] run scoreboard players set @a C_SHEARS_GET 1
execute as @a[scores={C_GLASS_GET=0}] if entity @a[nbt={Inventory:[{id:"minecraft:glass"}]}] run scoreboard players set @a C_GLASS_GET 1
execute as @a[scores={C_FIRE_GET=0}] if entity @a[nbt={Inventory:[{id:"minecraft:flint_and_steel"}]}] run scoreboard players set @a C_FIRE_GET 1

# Grant the collector advancement if every item has been collected!
advancement grant @a[scores={C_FIRE_GET=1,C_HELMET_GET=1,C_CHEST_GET=1,C_LEGGINGS_GET=1,C_BOOTS_GET=1,C_DOG_GET=1,C_PICK_GET=1,C_SWORD_GET=1,C_SHIELD_GET=1,C_AXE_GET=1,C_WATER_GET=1,C_TRIDENT_GET=1,C_BOW_GET=1,C_SHOVEL_GET=1,C_SHEARS_GET=1,C_GLASS_GET=1}] only t:challenges/collector

############
# Map tips #
############

# If the player just died, give them a tip
execute as @a[scores={DEATHS_LAST=0,C_DEATHS=1}] unless entity @s[x=7,y=37,z=-101,dx=21,dy=23,dz=90] run tellraw @s [{"text":"Tip: Every time you die you will earn a new tip. Or you can ","color":"aqua"},{"text":"open the chat and click here to disable tips","color":"aqua","underlined":"true","clickEvent":{"action":"run_command","value":"/scoreboard players set @s DEATHS_LAST 20000"}}]
execute as @a[scores={DEATHS_LAST=1,C_DEATHS=2}] unless entity @s[x=7,y=37,z=-101,dx=21,dy=23,dz=90] run tellraw @s [{"text":"Tip: There are a lot of enemies in this map, but none of them can break holoblocks. Build walls and bridges to outmaneuver your foes! ","color":"aqua"},{"text":"Open the chat and click here to disable future tips","color":"aqua","underlined":"true","clickEvent":{"action":"run_command","value":"/scoreboard players set @s DEATHS_LAST 20000"}}]
execute as @a[scores={DEATHS_LAST=2,C_DEATHS=3}] unless entity @s[x=7,y=37,z=-101,dx=21,dy=23,dz=90] run tellraw @s [{"text":"Tip: Your holoblock can also be used as a weapon! It deals 4 damage -- as much as a wooden sword! ","color":"aqua"},{"text":"Open the chat and click here to disable future tips","color":"aqua","underlined":"true","clickEvent":{"action":"run_command","value":"/scoreboard players set @s DEATHS_LAST 20000"}}]
execute as @a[scores={DEATHS_LAST=3,C_DEATHS=4}] unless entity @s[x=7,y=37,z=-101,dx=21,dy=23,dz=90] run tellraw @s [{"text":"Tip: Most spawners can be disabled with light. Surround them with torches to shut them down! ","color":"aqua"},{"text":"Open the chat and click here to disable future tips","color":"aqua","underlined":"true","clickEvent":{"action":"run_command","value":"/scoreboard players set @s DEATHS_LAST 20000"}}]
execute as @a[scores={DEATHS_LAST=4,C_DEATHS=5}] unless entity @s[x=7,y=37,z=-101,dx=21,dy=23,dz=90] run tellraw @s [{"text":"Tip: Most melee mobs can't reach you if you build up a few blocks. If you're being swarmed, pillar up! ","color":"aqua"},{"text":"Open the chat and click here to disable future tips","color":"aqua","underlined":"true","clickEvent":{"action":"run_command","value":"/scoreboard players set @s DEATHS_LAST 20000"}}]
execute as @a[scores={DEATHS_LAST=5,C_DEATHS=6}] unless entity @s[x=7,y=37,z=-101,dx=21,dy=23,dz=90] run tellraw @s [{"text":"Tip: Stuck on a dungeon that's too hard? Retreat and explore someplace else! You might find a weapon that can help you advance. ","color":"aqua"},{"text":"Open the chat and click here to disable future tips","color":"aqua","underlined":"true","clickEvent":{"action":"run_command","value":"/scoreboard players set @s DEATHS_LAST 20000"}}]
execute as @a[scores={DEATHS_LAST=6,C_DEATHS=7}] unless entity @s[x=7,y=37,z=-101,dx=21,dy=23,dz=90] run tellraw @s [{"text":"Tip: Spiders can't slip through gaps that are 1 block wide. Use your holoblock to build pillars and trap them! ","color":"aqua"},{"text":"Open the chat and click here to disable future tips","color":"aqua","underlined":"true","clickEvent":{"action":"run_command","value":"/scoreboard players set @s DEATHS_LAST 20000"}}]
execute as @a[scores={DEATHS_LAST=7,C_DEATHS=8}] unless entity @s[x=7,y=37,z=-101,dx=21,dy=23,dz=90] run tellraw @s [{"text":"Tip: Right click on your taterPad to open the shop. You can buy powerful items with Sol Credits. ","color":"aqua"},{"text":"Open the chat and click here to disable future tips","color":"aqua","underlined":"true","clickEvent":{"action":"run_command","value":"/scoreboard players set @s DEATHS_LAST 20000"}}]
execute as @a[scores={DEATHS_LAST=8,C_DEATHS=9}] unless entity @s[x=7,y=37,z=-101,dx=21,dy=23,dz=90] run tellraw @s [{"text":"Tip: Check every nook and cranny for hidden secrets. Powerful gear can be found in unexpected places... ","color":"aqua"},{"text":"Open the chat and click here to disable future tips","color":"aqua","underlined":"true","clickEvent":{"action":"run_command","value":"/scoreboard players set @s DEATHS_LAST 20000"}}]
execute as @a[scores={DEATHS_LAST=9,C_DEATHS=10}] unless entity @s[x=7,y=37,z=-101,dx=21,dy=23,dz=90] run tellraw @s [{"text":"Tip: Having a difficult time? Feel free to switch to easy difficulty, or even peaceful! ","color":"aqua"},{"text":"Open the chat and click here to disable future tips","color":"aqua","underlined":"true","clickEvent":{"action":"run_command","value":"/scoreboard players set @s DEATHS_LAST 20000"}}]
execute as @a[scores={DEATHS_LAST=10,C_DEATHS=11}] unless entity @s[x=7,y=37,z=-101,dx=21,dy=23,dz=90] run tellraw @s [{"text":"Last Tip: Don't feel bad about dying a lot! Just keep making progress with each life until you've found all four power sources!","color":"aqua"},{"text":"","color":"aqua","underlined":"true","clickEvent":{"action":"run_command","value":"/scoreboard players set @s DEATHS_LAST 20000"}}]
execute as @a[scores={DEATHS_LAST=20000}] run tellraw @s [{"text":"Tips are now disabled. ","color":"aqua"},{"text":"Click here to enable tips","color":"aqua","underlined":"true","clickEvent":{"action":"run_command","value":"/scoreboard players set @s DEATHS_LAST 10000"}}]
execute as @a[scores={DEATHS_LAST=20000}] run scoreboard players set @s DEATHS_LAST 20001
execute as @a[scores={DEATHS_LAST=10000}] run tellraw @s [{"text":"Tips are now enabled. ","color":"aqua"},{"text":"Click here to disable tips","color":"aqua","underlined":"true","clickEvent":{"action":"run_command","value":"/scoreboard players set @s DEATHS_LAST 20000"}}]
execute as @a[scores={DEATHS_LAST=..20000}] run scoreboard players operation @s DEATHS_LAST = @s C_DEATHS